unit MainWin;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;
type
  TMainFrm = class(TForm)
    ShowBtn: TButton;
    HideBtn: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    PopupMenu: TPopupMenu;
    ExitMI: TMenuItem;
    N1: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure ShowBtnClick(Sender: TObject);
    procedure HideBtnClick(Sender: TObject);
    procedure ModifyTray(Sender: TObject);
    procedure ExitMIClick(Sender: TObject);
    procedure N13Click(Sender: TObject);
  private
  public
    //    
    procedure WndProc (var Msg: TMessage); override;
  end;
var
  MainFrm: TMainFrm;
implementation
uses ShellApi;
{$R *.DFM}

const
  WM_ICONMESSAGE=WM_USER+10;

var
  TrIco:_NOTIFYICONDATA;

procedure TMainFrm.FormShow(Sender: TObject);
begin
  TrIco.cbSize:=SizeOf(_NOTIFYICONDATA);  //  
  TrIco.Wnd:=Handle;                      //  
  TrIco.uID:=1;                           //   
  TrIco.uCallbackMessage:=WM_ICONMESSAGE; // ,  


  TrIco.uFlags:=NIF_MESSAGE or NIF_ICON or NIF_TIP;
  TrIco.szTip:='  Tray Icon';        // Hint Tray Icon
  TrIco.hIcon:=Application.Icon.Handle;    //  
end;

procedure TMainFrm.ShowBtnClick(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_ADD,@TrIco);   // Show Tray Icon
  
  HideBtn.Enabled:=true;
  ShowBtn.Enabled:=false;
end;

procedure TMainFrm.HideBtnClick(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE,@TrIco); // Hide Tray Icon

  HideBtn.Enabled:=false;
  ShowBtn.Enabled:=true;
end;

procedure TMainFrm.ModifyTray(Sender: TObject);
begin
  TrIco.hIcon:=(Sender as TImage).Picture.Icon.Handle;
  StrLCopy(TrIco.szTip,PChar((Sender as TImage).Hint),64);
  
  Shell_NotifyIcon(NIM_MODIFY,@TrIco); // Modify Tray Icon
end;

procedure TMainFrm.WndProc(var Msg: TMessage);
var
  Pt:TPoint;
begin
  if Msg.Msg=WM_ICONMESSAGE then
    case Msg.LParam of
      WM_RBUTTONDOWN:   //    
        begin
          SetForegroundWindow(MainFrm.Handle);
          GetCursorPos(Pt);
          PopupMenu.Popup(Pt.x,Pt.y);   // 
        end;
      WM_LBUTTONDOWN:   //    
        begin
          SetForegroundWindow(MainFrm.Handle);
          HideBtnClick(Self);          // 
        end;
      // WM_MOUSEMOVE:;       //     
    end
  else inherited;
end;

procedure TMainFrm.ExitMIClick(Sender: TObject);
begin
  Close;
end;

procedure TMainFrm.N13Click(Sender: TObject);
begin
  ShowMessage((Sender as TMenuItem).Caption);
end;

end.
